#include "interface.h"
#include <SDL/SDL.h>

int     return_value = INTERFACE_MESSAGE_EXIT;
message_function	key_handlers[16];
long	key_handlers_count;

int		InterfaceInit(long *data){
	if(SDL_Init(SDL_INIT_NOPARACHUTE)){
		printf("Cann't init SDL library...\n");
		return -1;
	}
	return 0;
}

int		InterfaceMessage(message_function keys[],long func_count,long core_pos){
//	int working=1;
	SDL_Event event;
    int i;
    for(i=0;i<func_count;i++) key_handlers[i] = keys[i];
    key_handlers_count = func_count;
	while(1){
		SDL_WaitEvent(&event);
		switch(event.type){
		case SDL_QUIT:
			return 0;
		case SDL_KEYDOWN:
	    	for(i=0;i<key_handlers_count;i++)
	    		(*key_handlers[i])(0,event.key.keysym.scancode);

/*			if(event.key.keysym.scancode==0x01){
				CoreStop();
				switch(EmulatorInterface()){
				case 0:
					CoreClose();
					CoreShutdown();
					EmulatorExit(0);
					break;
				case 1:
					CoreStart();
					break;
				case 2:
					CoreClose();
					CoreOpen();
					CoreStart();
					break;
				default:
					CoreStart();
					break;
				}
			}*/
			break;
		case SDL_KEYUP:
	    	for(i=0;i<key_handlers_count;i++)
	    		(*key_handlers[i])(1,event.key.keysym.scancode);
	    	break;
		default:
			break;
		}
	}
	return 0;
}

int		InterfaceShutdown(int exit_code){
	SDL_Quit();
	return exit_code;
}

/******************************************************************************/
/*
//#include <stdlib.h>
#include <Application.h>
#include <Rect.h>
#include <Window.h>
#include <OS.h>
#include <Button.h>
#include <MenuBar.h>
#include <MenuItem.h>
#include <Menu.h>
#include <Message.h>
#include <SDL/SDL.h>

extern "C" int EmulatorInterface(void);

thread_id	cur_thread;
int			return_value=1;

class EmulatorInterfaceApp : public BApplication {
public:
	EmulatorInterfaceApp():BApplication("application/x-vnd.RbSoft-RbPSe"){}
	~EmulatorInterfaceApp(){}
};

class EmulatorUserWindow : public BWindow {
public:
	EmulatorUserWindow(BRect frame, const char *title, window_look look,
		window_feel feel, uint32 flags):BWindow(frame,title,look,feel,flags){}
	~EmulatorUserWindow(){}
	virtual void MessageReceived(BMessage *Message){
		switch(Message->what){
		case 'EXIT':
			return_value=0;
			break;
		case 'CONT':
			return_value=1;
			break;
//		case 'RSET':
//			return_value=2;
//			break;
		default:
			return;
		}
		resume_thread(cur_thread);
	}
};

int EmulatorInterface(void){
	cur_thread=find_thread(NULL);
//	BWindow *Wnd=be_app->WindowAt(0);
//	BMenuBar *WndMenuBar=new BMenuBar(BRect(0,0,20,20),"WndMenuBar");
//	Wnd->AddChild(WndMenuBar);
//	BMenu *WndMenu=new BMenu("Core");
//	WndMenuBar->AddItem(WndMenu);
//	BMenuItem *MenuItemExit=new BMenuItem("Exit",new BMessage('EXIT'));
//	WndMenu->AddItem(MenuItemExit);
	EmulatorUserWindow *Window=new EmulatorUserWindow(BRect(200,160,600,440),
		"Choose...",B_TITLED_WINDOW_LOOK,B_MODAL_APP_WINDOW_FEEL,
		B_NOT_MOVABLE|B_NOT_CLOSABLE|B_NOT_ZOOMABLE|B_NOT_MINIMIZABLE|B_NOT_RESIZABLE);
	BButton *b_quit=new BButton(BRect(10,10,100,30),"but00","Exit",new BMessage('EXIT'));
	BButton *b_cont=new BButton(BRect(110,10,200,30),"but01","Continue",new BMessage('CONT'));
//	BButton *b_rset=new BButton(BRect(210,10,300,30),"but02","Reset",new BMessage('RSET'));
	Window->AddChild(b_quit);
	Window->AddChild(b_cont);
//	Window->AddChild(b_rset);
	Window->Show();
	suspend_thread(find_thread(NULL));
	Window->Lock();
	Window->Quit();
	return return_value;
}*/