;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
CEXTERN RbPSe_fopen
CEXTERN RbPSe_fprintf
CEXTERN RbPSe_SysPrintf
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	mov edx,[RbPSeMainStrucAddr]											;F      I  e  a
	mov [RbPSeMainData+RbPSeMainStruc.Log___Printf___],dword dbg_printf		; o      n  r  c
	mov [edx+RbPSeMainStruc.Log___Printf___],dword dbg_printf				;  r      t  f  e
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
	mov eax,[esp+4]
		push dword 1
		push dword LogFileName
		push dword [eax+RbPSeStartUpStruc.LogfileDir]
		call RbPSe_fopen
		add esp,0x0c
	test eax,eax
	jnz .ok
	mov eax,[esp+4]
		push dword LogFileName
		push dword [eax+RbPSeStartUpStruc.LogfileDir]
		push dword ErrorOpen
		call RbPSe_SysPrintf
		add esp,0x0c
		mov eax,0xffffffff
		ret
.ok:
	mov [LogFileHandle],eax
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
dbg_printf:
	mov eax,[esp]
	mov edx,[LogFileHandle]
	mov [ret_save],eax
	mov [esp],edx
	call RbPSe_fprintf
	mov eax,[ret_save]
	mov [esp],eax
	ret
;------------------------------------------------------------------------------;
;LogExitDump:
;        pusha
;		push dword 1
;		push dword MemDumpFile
;		call Rb_fopen
;		add esp,0x08
;	push eax
;		push dword 0x00200000
;		push dword [BaseMemorySave]
;		push eax
;		call Rb_fwrite
;		add esp,0x0c
;	pop eax
;		push eax
;		call Rb_fclose
;		add esp,0x04
;	popa
;	jmp $		;tmp
;	ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
LogFileHandle		dd	0
ret_save			dd	0
LogFileName			db	"__log__.log",0
ErrorOpen			db	"Error open %s ,, %s ",10,0
;MemDumpFile		db	"__mem__.dmp",0
Message_WriteHWWord	db	"{ %X } :: Write HW Word { %X } to { %X }",13,10,0
Message_ReadHWWord	db	"{ %X } ++ Read HW Word { %X } at { %X }",13,10,0
Message_WriteHWHalf	db	"{ %X } :: Write HW Half { %X } to { %X }",13,10,0
Message_ReadHWHalf	db	"{ %X } ++ Read HW Half { %X } at { %X }",13,10,0
Message_WriteHWByte	db	"{ %X } :: Write HW Byte { %X } to { %X }",13,10,0
Message_ReadHWByte	db	"{ %X } ++ Read HW Byte { %X } at { %X }",13,10,0
;MSG_UnsupportedCall	db	"...???Warning???Unsupported Call [ %X ]::[ %X ]",13,10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
