typedef	long (*message_function)(long,long);

#ifdef __cplusplus
extern "C" {
#endif
int     InterfaceInit(long*);
int     InterfaceMessage(message_function[],long,long);
int		InterfaceConfigure();
int		InterfaceShutdown(int);
#ifdef __cplusplus
}
#endif

enum {
    CORE_STATE_NONE = 0,
    CORE_STATE_INIT = 1,
    CORE_STATE_OPEN = 2,
    CORE_STATE_START = 3
};

enum {
	INTERFACE_MESSAGE_EXIT = 0,
    INTERFACE_MESSAGE_STOP = 1,
    INTERFACE_MESSAGE_RESET = 2,
    INTERFACE_MESSAGE_START = 3
};


