#include "rbpse.const.h"

#ifdef __cplusplus
extern "C" {
#endif
int		RbPSePluginInit(RbPSeDataStruc*,RbPSeHookStruc*,RbPSeFuncStruc*,RbPSeStartStruc*);
int		RbPSePluginReset();
int		RbPSePluginOpen();
int		RbPSePluginClose();
int		RbPSePluginShutdown();
int		RbPSePluginAbout();
int		RbPSePluginConfigure();
#ifdef __cplusplus
}
#endif

extern	char*		RbPSePluginName;
extern	char*		RbPSePluginVersion;
extern	long long	RbPSePluginType;
extern	long long	RbPSePluginNeed;

enum {
	TYPE_NONE				= 0x0000000000000000,
	TYPE_LIBRARY_DEBUG		= 0x0000000000000001,
	TYPE_LIBRARY_MEMORY		= 0x0000000000000002,
	TYPE_LIBRARY_HARDWARE	= 0x0000000000000004,
	TYPE_LIBRARY_CPUDYN		= 0x0000000000000008,
	TYPE_PLUGINS_COP0		= 0x0000000000000010,
	TYPE_PLUGINS_DMA		= 0x0000000000000020,
	TYPE_PLUGINS_HLE		= 0x0000000000000040,
	TYPE_PLUGINS_GPU        = 0x0000000000000080
};

