#include <string.h>
#include <image.h>
#include "system.h"

long	RbPSe_LoadLibrary(const char *path, const char *name,
			const char **LibFuncs, long LibHandles[]){
	image_id lib;
	char tmp[256];
	int i=1;
	if(path) strcat(strcat(strcpy(tmp,path),"/"),name); else strcpy(tmp,name);
	lib=load_add_on(tmp);
	if(lib<B_OK)
	{
		printf("load_add_on(\"%s\") - failed : %i ",tmp,lib);
		return -1;
	}
	LibHandles[0]=lib;
	while(*LibFuncs){
		if(B_OK==get_image_symbol(lib,*LibFuncs,B_SYMBOL_TYPE_TEXT,(void**)&LibHandles[i])){
			LibFuncs++;
			i++;
		}else{
			printf("get_image_symbol(\"%s\") - failed",*LibFuncs);
			unload_add_on(lib);
			return -2;
		}
	}
	return 0;
}
