#include <windows.h>
#include <string.h>
#include <stdio.h>
#include "system.h"

long	RbPSe_LoadLibrary(const char *path, const char *name,
			const char **LibFuncs, long LibHandles[6]){
	HMODULE lib;
	char tmp[256];
	int i=1;
	if(path) strcat(strcat(strcpy(tmp,path),"\\"),name); else strcpy(tmp,name);
	lib=LoadLibrary(tmp);
	if(!lib){
//    	printf("LoadLibrary(%s) - failed : %x",tmp,GetLastError());
    	return -1;
    }
	LibHandles[0]=(long)lib;
	while(*LibFuncs){
		if((LibHandles[i]=(long)GetProcAddress(lib,*LibFuncs))){
			LibFuncs++;
			i++;
		}else{
//        	printf("GetProcAddress(%x,%s) - failed : %x",lib,*LibFuncs,GetLastError());
			FreeLibrary(lib);
			return -2;
		}
	}
	return 0;
}
