;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
;======import======
;Interface:
;	[___rb___Hook___RUNTIME___]		(memory)
;Run--Time:	(None)
;BIOS-Call:	(None)
;======export======
;Interface:     (None)
;Run--Time:	(None)
;BIOS-Call:	(None)
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
	mov eax,copMFC0
	mov ecx,___mfc0
	rb_call ___rb___Hook___Table___
	mov eax,copMTC0
	mov ecx,___mtc0
	rb_call ___rb___Hook___Table___
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
copMFC0:
	and edx,0x000000ff
	mov eax,[___C00+edx]
	ret
;------------------------------------------------------------------------------;
copMTC0:
	and edx,0x000000ff
	mov [___C00+edx],eax
	ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
;LOG_mfc0	db	"---Cop0---[ %X ]   Read  [ %X ] from [ %X ]",13,10,0
;LOG_mtc0	db	"---Cop0---[ %X ]  Write  [ %X ]  to  [ %X ]",13,10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
___C00		resd	1
___C01		resd	1
___C02		resd	1
___C03		resd	1
___C04		resd	1
___C05		resd	1
___C06		resd	1
___C07		resd	1
___C08		resd	1
___C09		resd	1
___C0a		resd	1
___C0b		resd	1
___SR		resd	1
___CAUSE	resd	1
___EPC		resd	1
___C0f		resd	1