;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
CEXTERN RbPSe_fopen
CEXTERN RbPSe_fprintf
CEXTERN RbPSe_fflush
CEXTERN	RbPSe_SysPrintf
CEXTERN	RbPSe_fclose
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	INSTALL_FUNC Log___Printf___,Log___Printf___
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
	mov eax,[esp+4]
		push dword 1
		push dword LogFileName
		push dword [eax+RbPSeStartStruc.LogfileDir]
		call RbPSe_fopen
		add esp,0x0c
	test eax,eax
	jnz .ok
	mov eax,[esp+4]
		push dword LogFileName
		push dword [eax+RbPSeStartStruc.LogfileDir]
		push dword ErrorOpen
		call RbPSe_SysPrintf
		add esp,0x0c
		mov eax,0xffffffff
		ret
.ok:
	mov [LogFileHandle],eax
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
		push dword [LogFileHandle]
        call RbPSe_fclose
        add esp,0x04
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
Log___Printf___:
	mov eax,[esp]
	mov edx,[LogFileHandle]
	mov [ret_save],eax
	mov [esp],edx
	call RbPSe_fprintf
;    call RbPSe_fflush
	mov eax,[ret_save]
	mov [esp],eax
	ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
LogFileHandle		dd	0
ret_save			dd	0
LogFileName			db	"__log__.log",0
ErrorOpen			db	"Error open %s/%s ",10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
