;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
CEXTERN psxRegs
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
        xor eax,eax
        ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
;	mov dword [RegRegister+___RTPS]         ,dword  gteRTPS         ;01
	mov eax,gteRTPS
	mov ecx,___RTPS
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___NCLIP]	,dword	gteNCLIP	;06;ok_
	mov eax,gteNCLIP
	mov ecx,___NCLIP
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___DPCS]		,dword	gteDPCS
	mov eax,gteDPCS
	mov ecx,___DPCS
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___MVMVA]	,dword	gteMVMVA	;12
	mov eax,gteMVMVA
	mov ecx,___MVMVA
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___NCDS]		,dword	gteNCDS		;13
	mov eax,gteNCDS
	mov ecx,___NCDS
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___NCDT]		,dword	gteNCDT		;16
	mov eax,gteNCDT
	mov ecx,___NCDT
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___NCCS]		,dword	gteNCCS		;1b;ok_
	mov eax,gteNCCS
	mov ecx,___NCCS
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___SQR]		,dword	gteSQR		;28
	mov eax,gteSQR
	mov ecx,___SQR
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___DCPL]		,dword	gteDCPL		;29
	mov eax,gteDCPL
	mov ecx,___DCPL
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___AVSZ3]	,dword	gteAVSZ3	;2d;ok
	mov eax,gteAVSZ3
	mov ecx,___AVSZ3
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___AVSZ4]	,dword	gteAVSZ4	;2e;ok
	mov eax,gteAVSZ4
	mov ecx,___AVSZ4
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___RTPT]         ,dword  gteRTPT		;30
	mov eax,gteRTPT
	mov ecx,___RTPT
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___GPF]          ,dword  gteGPF		;3d;ok_
	mov eax,gteGPF
	mov ecx,___GPF
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___GPL]          ,dword  gteGPL          ;3e;ok_
	mov eax,gteGPL
	mov ecx,___GPL
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___NCCT]		,dword	gteNCCT		;3f;ok_
	mov eax,gteNCCT
	mov ecx,___NCCT
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___mfc2]		,dword	gteMFC2
	mov eax,gteMFC2
	mov ecx,___mfc2
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___cfc2]		,dword	gteCFC2
	mov eax,gteCFC2
	mov ecx,___cfc2
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___mtc2]		,dword	gteMTC2
	mov eax,gteMTC2
	mov ecx,___mtc2
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___ctc2]		,dword	gteCTC2
	mov eax,gteCTC2
	mov ecx,___ctc2
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___lwc2]		,dword	gteLWC2
	mov eax,gteLWC2
	mov ecx,___lwc2
	rb_call ___rb___Hook___Table___
;	mov dword [RegRegister+___swc2]		,dword  gteSWC2
	mov eax,gteSWC2
	mov ecx,___swc2
	rb_call ___rb___Hook___Table___
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
        xor eax,eax
        ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
        xor eax,eax
        ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
        xor eax,eax
        ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
        xor eax,eax
        ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
        xor eax,eax
        ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
        xor eax,eax
        ret
;------------------------------------------------------------------------------;
CEXTERN _gteRTPS
gteRTPS:
;---
;	push eax
;	call printEDI
;	pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteRTPS
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
CEXTERN _gteNCLIP
gteNCLIP:			;;;Comlete;;;;;;
;---
;	push eax
;	call printEDI
;	pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteNCLIP
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;---
;------------------------------------------------------------------------------;
CEXTERN _gteDPCS
gteDPCS:	;;NOT!!!
;---
;	push eax
;	call printEDI
;        pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteDPCS
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
CEXTERN _gteMVMVA
gteMVMVA:
;	push eax
;	call printEDI
;	pop eax
;392-Control
;264-Data
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteMVMVA
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
CEXTERN _gteNCDS
gteNCDS:
;	push eax
;	call printEDI
;	pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteNCDS
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
CEXTERN _gteNCDT
gteNCDT:
;	push eax
;	call printEDI
;	pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteNCDT
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
CEXTERN _gteNCCS
gteNCCS:
;	push eax
;	call printEDI
;	pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteNCCS
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
CEXTERN _gteSQR
gteSQR:
;	push eax
;	call printEDI
;	pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteSQR
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
CEXTERN _gteDCPL
gteDCPL:
;	push eax
;	call printEDI
;	pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteDCPL
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
CEXTERN _gteAVSZ3
gteAVSZ3:			;;;FullComplete;;;Cann't be errorsz
;	push eax
;	call printEDI
;	pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteAVSZ3
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
CEXTERN _gteAVSZ4
gteAVSZ4:                       ;;;FullComplete;;;Cann't be errorsz
;	push eax
;	call printEDI
;	pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteAVSZ4
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
CEXTERN _gteRTPT
gteRTPT:
;	push eax
;	call printEDI
;	pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteRTPT
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
CEXTERN _gteGPF
gteGPF:				;(3d);		
;	push eax
;	call printEDI
;	pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteGPF
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
CEXTERN _gteGPL
gteGPL:			;(3e);			
;	push eax
;	call printEDI
;	pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteGPL
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
CEXTERN _gteNCCT
gteNCCT:		;(3f);		;
;	push eax
;	call printEDI
;	pop eax
;---
	pusha
	mov [psxRegs+524],edx
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,eax
	mov edi,edx
	mov ecx,0x40
	rep movsd
	call _gteNCCT
	popa
	pusha
	lea eax,[___VXY0]
	lea edx,[psxRegs+264]
	mov esi,edx
	mov edi,eax
	mov ecx,0x40
	rep movsd
	popa
	ret
;------------------------------------------------------------------------------;
;-------L-O-A-D--&--S-T-O-R-E--I-N-S-T-R-U-C-T-I-O-N-S-------------------------;
;------------------------------------------------------------------------------;
gteMFC2:
	and edx,0x000000ff
	jmp [MFC2_func+edx]
;------------------------------------------------------------------------------;
mfc2_usual:
	mov eax,[edx+__Cop2d__]
	ret
mfc2_error:
	jmp $
;------------------------------------------------------------------------------;
gteCFC2:
	and edx,0x000000ff
	jmp [CFC2_func+edx]
;------------------------------------------------------------------------------;
cfc2_usual:
        mov eax,[edx+__Cop2c__]
        ret
cfc2_error:
        jmp $
;------------------------------------------------------------------------------;
gteMTC2:
	and edx,0x000000ff
	jmp [MTC2_func+edx]
;------------------------------------------------------------------------------;
mtc2_usual:
	mov [edx+__Cop2d__],eax
	ret
mtc2_error:
	jmp $
;------------------------------------------------------------------------------;
mtc2___IR0:
	movsx eax,ax
        mov [___IR0],eax
        ret
mtc2___IR1:
	movsx eax,ax
        mov [___IR1],eax
        ret
mtc2___IR2:
	movsx eax,ax
        mov [___IR2],eax
        ret
mtc2___IR3:
	movsx eax,ax
        mov [___IR3],eax
        ret
mtc2___SZ0:
        movzx eax,ax
        mov [___SZ0],eax
        ret
mtc2___SZ1:
	movzx eax,ax
	mov [___SZ1],eax
	ret
mtc2___SZ2:
        movzx eax,ax
        mov [___SZ2],eax
        ret
mtc2___SZ3:
        movzx eax,ax
        mov [___SZ3],eax
        ret
mtc2__LZCS:
	mov [___LZCS],eax
	mov edx,0x20
	cmp eax,0x00
	jg .pozitiv
	je .zero
	not eax
.pozitiv:
	dec edx
	bsr ecx,eax
	sub edx,ecx
.zero:
	mov [___LZCR],edx
	ret
;------------------------------------------------------------------------------;
gteCTC2:
	and edx,0x000000ff
	jmp [CTC2_func+edx]
;------------------------------------------------------------------------------;
ctc2_usual:
        mov [edx+__Cop2c__],eax
        ret
ctc2_error:
        jmp $
;------------------------------------------------------------------------------;
gteLWC2:
	and edx,0x000000ff
	push edx
	q_call MemoryRead32
	pop edx
	jmp [MTC2_func+edx]
;------------------------------------------------------------------------------;
gteSWC2:
	and edx,0x000000ff
	mov eax,[__Cop2d__+edx]
	q_call MemoryWrite32
	ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------;
MFC2_func:
	dd	mfc2_usual,mfc2_usual,mfc2_usual,mfc2_usual
	dd	mfc2_usual,mfc2_usual,mfc2_usual,mfc2_usual
	dd	mfc2_usual,mfc2_usual,mfc2_usual,mfc2_usual
	dd	mfc2_usual,mfc2_usual,mfc2_usual,mfc2_usual
	dd	mfc2_usual,mfc2_usual,mfc2_usual,mfc2_usual
	dd	mfc2_usual,mfc2_usual,mfc2_usual,mfc2_error
	dd	mfc2_usual,mfc2_usual,mfc2_usual,mfc2_usual
	dd	mfc2_error,mfc2_error,mfc2_error,mfc2_usual
CFC2_func:
        dd      cfc2_usual,cfc2_usual,cfc2_usual,cfc2_usual
        dd      cfc2_usual,cfc2_usual,cfc2_usual,cfc2_usual
        dd      cfc2_usual,cfc2_usual,cfc2_usual,cfc2_usual
        dd      cfc2_usual,cfc2_usual,cfc2_usual,cfc2_usual
        dd      cfc2_usual,cfc2_usual,cfc2_usual,cfc2_usual
        dd      cfc2_usual,cfc2_usual,cfc2_usual,cfc2_usual
        dd      cfc2_usual,cfc2_usual,cfc2_usual,cfc2_usual
        dd      cfc2_usual,cfc2_usual,cfc2_usual,cfc2_usual
MTC2_func:
	dd      mtc2_usual,mtc2_usual,mtc2_usual,mtc2_usual
	dd      mtc2_usual,mtc2_usual,mtc2_usual,mtc2_usual
	dd	mtc2___IR0,mtc2___IR1,mtc2___IR2,mtc2___IR3
	dd      mtc2_usual,mtc2_usual,mtc2_usual,mtc2_usual
	dd	mtc2___SZ0,mtc2___SZ1,mtc2___SZ2,mtc2___SZ3
	dd      mtc2_usual,mtc2_usual,mtc2_usual,mtc2_usual
	dd      mtc2_usual,mtc2_usual,mtc2_usual,mtc2_usual
	dd	mtc2_error,mtc2_error,mtc2__LZCS,mtc2_error
CTC2_func
	dd      ctc2_usual,ctc2_usual,ctc2_usual,ctc2_usual
	dd      ctc2_usual,ctc2_usual,ctc2_usual,ctc2_usual
	dd      ctc2_usual,ctc2_usual,ctc2_usual,ctc2_usual
	dd      ctc2_usual,ctc2_usual,ctc2_usual,ctc2_usual
	dd      ctc2_usual,ctc2_usual,ctc2_usual,ctc2_usual
	dd      ctc2_usual,ctc2_usual,ctc2_usual,ctc2_usual
	dd      ctc2_usual,ctc2_usual,ctc2_usual,ctc2_usual
	dd      ctc2_usual,ctc2_usual,ctc2_usual,ctc2_usual
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
;------------------GTE-DATA----------------------------------------------------;
__Cop2d__
___VXY0		resd    1
___VZ0		resd    1
___VXY1		resd    1
___VZ1		resd    1
___VXY2		resd    1
___VZ2		resd    1
___RGB_		resd    1
___OTZ		resd    1
___IR0		resd    1
___IR1		resd    1
___IR2		resd    1
___IR3		resd    1
___SXY0		resd    1
___SXY1		resd    1
___SXY2		resd    1
___SXYP		resd    1
___SZ0		resd    1
___SZ1		resd    1
___SZ2		resd    1
___SZ3		resd    1
___RGB0		resd    1
___RGB1		resd    1
___RGB2		resd    1
___RES1		resd    1
___MAC0		resd    1
___MAC1		resd    1
___MAC2		resd    1
___MAC3		resd    1
___IRGB		resd    1
___ORGB		resd    1
___LZCS		resd    1
___LZCR		resd    1
;------------------GTE-CONTROL-------------------------------------------------;
__Cop2c__
___R11R12	resd    1
___R13R21	resd    1
___R22R23	resd    1
___R31R32	resd    1
___R33		resd    1
___TRX		resd    1
___TRY		resd    1
___TRZ		resd    1
___L11L12	resd    1
___L13L21	resd    1
___L22L23	resd    1
___L31L32	resd    1
___L33		resd    1
___RBK		resd    1
___GBK		resd    1
___BBK		resd    1
___LR1LR2	resd    1
___LR3LG1	resd    1
___LG2LG3	resd    1
___LB1LB2	resd    1
___LB3		resd    1
___RFC		resd    1
___GFC		resd    1
___BFC		resd    1
___OFX		resd    1
___OFY		resd    1
___H		resd    1
___DQA		resd    1
___DQB		resd    1
___ZSF3		resd    1
___ZSF4		resd    1
___FLAG		resd    1
;------------------------------------------------------------------------------;