;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
;Interface:	(None)
;BIOS Call:
;[A0]
;	(13)	set_jmp
;	(18)	strncmp
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
;%define __HLE_CLOG
%macro LogHLE_CLOG 1
	%ifdef __HLE_CLOG
		push dword [byte RegRegister + r___A3___b]
		push dword [byte RegRegister + r___A2___b]
		push dword [byte RegRegister + r___A1___b]
		push dword [byte RegRegister + r___A0___b]
		push dword %1
		rb_call ___rb___Log___Printf___
		add esp,0x14
	%endif
%endmacro
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
;---
	mov eax,A0_13
	mov ecx,0x0013
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_15
	mov ecx,0x0015
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_17
	mov ecx,0x0017
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_18
	mov ecx,0x0018
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_19
	mov ecx,0x0019
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_1B
	mov ecx,0x001B
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_25
	mov ecx,0x0025
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_28
	mov ecx,0x0028
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_2A
	mov ecx,0x002A
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_2B
	mov ecx,0x002B
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_2F
	mov ecx,0x002F
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_30
	mov ecx,0x0030
	rb_call ___rb___Hook___hleA0___
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
;int setjmp(jmp_buf env)
A0_13:
	LogHLE_CLOG ___log___A0___13
	mov eax,[byte RegRegister + r___A0___b]
	and eax,0x001fffff
	mov edx,[byte RegRegister + r___RA___b]
	mov [MemRegister+eax+JB_IntRA],edx
	mov edx,[byte RegRegister + r___SP___b]
	mov [MemRegister+eax+JB_IntSP],edx
	mov edx,[byte RegRegister + r___FP___b]
	mov [MemRegister+eax+JB_IntFP],edx
	mov edx,[byte RegRegister + r___S0___b]
	mov [MemRegister+eax+JB_IntS0],edx
	mov edx,[byte RegRegister + r___S1___b]
	mov [MemRegister+eax+JB_IntS1],edx
	mov edx,[byte RegRegister + r___S2___b]
	mov [MemRegister+eax+JB_IntS2],edx
	mov edx,[byte RegRegister + r___S3___b]
	mov [MemRegister+eax+JB_IntS3],edx
	mov edx,[byte RegRegister + r___S4___b]
	mov [MemRegister+eax+JB_IntS4],edx
	mov edx,[byte RegRegister + r___S5___b]
	mov [MemRegister+eax+JB_IntS5],edx
	mov edx,[byte RegRegister + r___S6___b]
	mov [MemRegister+eax+JB_IntS6],edx
	mov edx,[byte RegRegister + r___S7___b]
	mov [MemRegister+eax+JB_IntS7],edx
	mov edx,[byte RegRegister + r___GP___b]
	mov [MemRegister+eax+JB_IntGP],edx
	mov [byte RegRegister + r___V0___b],dword 0x00000000
	ret
;------------------------------------------------------------------------------;
;char *strcat(char *dst,char *src)
A0_15:
	LogHLE_CLOG ___log___A0___15
	cmp dword [byte RegRegister + r___A0___b],0x00000000
	je .error_exit
	cmp dword [byte RegRegister + r___A1___b],0x00000000
	jne .str_cat
.error_exit:
	mov [byte RegRegister + r___V0___b],dword 0x00000000
	ret
.str_cat:
	push esi
	push edi
	mov edx,[byte RegRegister + r___A0___b]
	and edx,0x001fffff
	add edx,MemRegister
	mov edi,edx
	xor eax,eax
	mov ecx,0x00010000
	repne scasb
	dec edi
	mov esi,[byte RegRegister + r___A1___b]
	and esi,0x001fffff
	add esi,[esp]
.str_cat_loop:
	lodsb
	stosb
	cmp al,0x00
	jne .str_cat_loop
	pop edi
	pop esi
	mov eax,[byte RegRegister + r___A0___b]
	mov [byte RegRegister + r___V0___b],eax
	ret
;------------------------------------------------------------------------------;
;int strcmp(char *dst,char *src)
A0_17:
	LogHLE_CLOG ___log___A0___17
	mov eax,[byte RegRegister + r___A0___b]
	cmp eax,0x00000000
	je  .step1
	cmp [byte RegRegister + r___A1___b],dword 0x00000000
	jne .compare
.step1:
	cmp eax,[byte RegRegister + r___A1___b]
	jne .step2
	mov [byte RegRegister + r___V0___b],dword 0x00000000        ;dst=src=0
	ret
.step2:
	cmp eax,0x00000000
	jne .step3
	mov [byte RegRegister + r___V0___b],dword 0xffffffff        ;dst=0;src!=0
	ret
.step3:
	mov [byte RegRegister + r___V1___b],dword 0x00000001        ;dst!=0;src=0
	ret
.compare:
	mov ecx,[byte RegRegister + r___A0___b]
	mov edx,[byte RegRegister + r___A1___b]
	and ecx,0x001fffff
	and edx,0x001fffff
	add ecx,MemRegister
	add edx,MemRegister
	xor eax,eax
	dec ecx
	dec edx
.loop:
	inc ecx
	inc edx
	mov al,[ecx]
	sub al,[edx]
	jnz .exit
	cmp byte [edx],byte 0x00
	jne .loop
.exit:
	movsx eax,al
	mov [byte RegRegister + r___V0___b],eax
	ret
;------------------------------------------------------------------------------;
;int strncmp(char *dst,char *src,int n)
A0_18:
	LogHLE_CLOG ___log___A0___18
	mov eax,[byte RegRegister + r___A0___b]
	cmp eax,0x00000000
	je  .step1
	cmp [byte RegRegister + r___A1___b],dword 0x00000000
	jne .compare
.step1:
	cmp eax,[byte RegRegister + r___A1___b]
	jne .step2
	mov [byte RegRegister + r___V0___b],dword 0x00000000        ;dst==src==NULL
	ret
.step2:
	cmp eax,0x00000000
	jne .step3
	mov [byte RegRegister + r___V0___b],dword 0xffffffff        ;dst==NULL | src!=NULL
	ret
.step3:
	mov [byte RegRegister + r___V0___b],dword 0x00000001        ;dst!=NULL | src==NULL
	ret
.compare:
	mov ecx,[byte RegRegister + r___A0___b]
	mov edx,[byte RegRegister + r___A1___b]
	and ecx,0x001fffff
	and edx,0x001fffff
	add ecx,MemRegister
	add edx,MemRegister
	push ebx
	mov ebx,[byte RegRegister + r___A2___b]
	xor eax,eax
	dec ecx
	dec edx
.loop:
	inc ecx
	inc edx
	dec ebx
	jl .exit
	mov al,[ecx]
	sub al,[edx]
	jnz .exit
	cmp byte [edx],byte 0x00
	jne .loop
.exit:
	pop ebx
	movsx eax,al
	mov [byte RegRegister + r___V0___b],eax
	ret
;------------------------------------------------------------------------------;
;char *strcpy(char *dst,char *src)
;;;;Speed
A0_19:
	LogHLE_CLOG ___log___A0___19
	cmp dword [byte RegRegister + r___A0___b],0x00000000
	je .error_exit
	cmp dword [byte RegRegister + r___A1___b],0x00000000
	jne .str_cpy
.error_exit:
	mov [byte RegRegister + r___V0___b],dword 0x00000000
	ret
.str_cpy:
	push esi
	push edi
	mov edi,[byte RegRegister + r___A0___b]
	and edi,0x001fffff
	add edi,[esp]
	mov esi,[byte RegRegister + r___A1___b]
	and esi,0x001fffff
	add esi,[esp]
.str_cpy_loop:
	lodsb
	stosb
	cmp al,0x00
	jne .str_cpy_loop
	pop edi
	pop esi
	mov eax,[byte RegRegister + r___A0___b]
	mov [byte RegRegister + r___V0___b],eax
	ret
;------------------------------------------------------------------------------;
;int strlen(char *s)
;;;;Full;;;
A0_1B:
	LogHLE_CLOG ___log___A0___1B
	mov edx,[byte RegRegister + r___A0___b]
	cmp edx,0x00000000
	jne .len
	mov [byte RegRegister + r___V0___b],dword 0x00000000
	ret
.len:
	and edx,0x001fffff
	add edx,MemRegister
	push edi
	xor eax,eax
	mov edi,edx
	mov ecx,0x00010000
	repne scasb
	sub edi,edx
	mov eax,edi
	pop edi
	dec eax
	mov [byte RegRegister + r___V0___b],eax
	ret
;------------------------------------------------------------------------------;
;char toupper(char c)
A0_25:
	LogHLE_CLOG ___log___A0___25
	movsx eax,byte [byte RegRegister + r___A0___b]
	mov dl,[CharTable+eax]
	test dl,0x02
	jz .exit
	sub eax,0x20
.exit
	mov [byte RegRegister + r___V0___b],eax
	ret
;------------------------------------------------------------------------------;
;void bzero(void *ptr,int len)
A0_28:
	LogHLE_CLOG ___log___A0___28
	cmp dword [byte RegRegister + r___A0___b],byte 0x00
	jz .exit
	cmp dword [byte RegRegister + r___A1___b],byte 0x00
	jle .exit
	push edi
	mov edi,[byte RegRegister + r___A0___b]
	mov ecx,[byte RegRegister + r___A1___b]
	and edi,0x001fffff
	mov [byte RegRegister + r___V0___b],ecx
	add edi,[esp]
	mov eax,0x00
	rep stosb
	pop edi
	ret
.exit:
	mov dword [byte RegRegister + r___V0___b],0x00000000
	ret
;------------------------------------------------------------------------------;
;char *memcpy(char *dst,char *src,int n)
A0_2A:
	LogHLE_CLOG ___log___A0___2A
	pusha
	mov eax,RegRegister
	mov edx,MemRegister
	mov ecx,[byte eax + r___A2___b]
	mov esi,[byte eax + r___A1___b]
	mov edi,[byte eax + r___A0___b]
	test edi,edi
	jz .zero
	mov [byte eax + r___V0___b],edi
	and esi,0x001fffff
	and edi,0x001fffff
	add esi,edx
	add edi,edx
	rep movsb
	popa
	ret
.zero:
	mov [byte eax + r___V0___b],dword 0x00000000
	popa
	ret
;------------------------------------------------------------------------------;
;void *memset(void *dst,char c,int n)
A0_2B:
	LogHLE_CLOG ___log___A0___2B
	push edi
	mov edi,[byte RegRegister + r___A0___b]
	mov eax,[byte RegRegister + r___A1___b]
	mov ecx,[byte RegRegister + r___A2___b]
	push edi
	and edi,0x001fffff
	add edi,[esp+4]
	rep stosb
	pop eax
	pop edi
	mov [byte RegRegister + r___V0___b],eax
	ret
;------------------------------------------------------------------------------;
;int rand()
;;;;Full
A0_2F:
	LogHLE_CLOG ___log___A0___2F
	mov eax,[MemRegister+0x00009010]
	mov ecx,0x41c64e6d
	mul ecx
	add eax,0x00003039
	mov [MemRegister+0x00009010],eax
	shr eax,0x10
	and eax,0x00007fff
	mov [byte RegRegister + r___V0___b],eax
	ret
;------------------------------------------------------------------------------;
;void srand(unsigned int seed)
A0_30:
	LogHLE_CLOG ___log___A0___30
	mov eax,[byte RegRegister + r___A0___b]
	mov [MemRegister+0x00009010],eax                ;9010 - _seed
	ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
CharTable:
        db      0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
        db      0x20,0x08,0x08,0x08,0x08,0x08,0x20,0x20
        db      0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
        db      0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
        db      0x18,0x10,0x10,0x10,0x10,0x10,0x10,0x10
        db      0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10
        db      0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04
        db      0x04,0x04,0x10,0x10,0x10,0x10,0x10,0x10
        db      0x10,0x41,0x41,0x41,0x41,0x41,0x41,0x01
        db      0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01
        db      0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01
        db      0x01,0x01,0x01,0x10,0x10,0x10,0x10,0x10
        db      0x10,0x42,0x42,0x42,0x42,0x42,0x42,0x02
        db      0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02
        db      0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02
        db      0x02,0x02,0x02,0x10,0x10,0x10,0x10,0x20
___log___A0___13	db	"---HLE---|  C  |(A0:13)---setjmp( 0x%X )",13,10,0
___log___A0___15	db	"---HLE---|  C  |(A0:15)---strcat( 0x%X , 0x%X )",13,10,0
___log___A0___17	db	"---HLE---|  C  |(A0:17)---strcmp( 0x%X , 0x%X )",13,10,0
___log___A0___18	db	"---HLE---|  C  |(A0:18)---strncmp( 0x%X , 0x%X , 0x%X )",13,10,0
___log___A0___19	db	"---HLE---|  C  |(A0:19)---strcpy( 0x%X , 0x%X )",13,10,0
___log___A0___1B	db	"---HLE---|  C  |(A0:1B)---strlen( 0x%X )",13,10,0
___log___A0___25	db	"---HLE---|  C  |(A0:25)---toupper( 0x%X )",13,10,0
___log___A0___28	db	"---HLE---|  C  |(A0:28)---bzero( 0x%X , 0x%X )",13,10,0
___log___A0___2A	db	"---HLE---|  C  |(A0:2A)---memcpy( 0x%X , 0x%X , 0x%X )",13,10,0
___log___A0___2B	db	"---HLE---|  C  |(A0:2B)---memset( 0x%X , 0x%X , 0x%X )",13,10,0
___log___A0___2F	db	"---HLE---|  C  |(A0:2F)---rand()",13,10,0
___log___A0___30	db	"---HLE---|  C  |(A0:30)---srand( 0x%X )",13,10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
