;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
;%define HLEMiscLog
;
;%macro LogHLEMiscLog 1
;        %ifdef HLEMiscLog
;                        push dword [RegRegister+___A3]
;                        push dword [RegRegister+___A2]
;                        push dword [RegRegister+___A1]
;                        push dword [RegRegister+___A0]
;                        push dword %1
;                        call Log_printf
;                        add esp,0x14
;        %endif
;%endmacro
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
;---
	mov eax,A0_44
	mov ecx,0x0044
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_72
	mov ecx,0x0072
	rb_call ___rb___Hook___hleA0___
;        mov eax,A0_9F
;        mov ecx,0x009F
;        call A0HLEHook
	mov eax,B0_56
	mov ecx,0x0056
	rb_call ___rb___Hook___hleB0___
	mov eax,B0_57
	mov ecx,0x0057
	rb_call ___rb___Hook___hleB0___
;---
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
;FlushCache
A0_44:
        ret
;------------------------------------------------------------------------------;
;_96_remove             ;BIOSMemory
A0_72:
;EnterCriticalSection
        mov ecx,0x01
        q_call q___system
;b0_09(*0x0000b9b8)
;b0_09(*0x0000b9bc)
;b0_09(*0x0000b9c0)
;b0_09(*0x0000b9c4)
;b0_09(*0x0000b9c8)
;a0_a3()
	ret
;------------------------------------------------------------------------------;
;void SetMem(int size)
;A0_9F:
;        mov ecx,0x00001060
;        q_call HardWareRead32
;        and eax,0xfffff8ff
;        mov edx,[RegRegister+___A0]
;        cmp edx,0x02
;        jne .not2
;        q_call HardWareWrite32
;        ret
;.not2:
;        cmp edx,0x08
;        jne .not8
;        or eax,0x00000300
;        q_call HardWareWrite32
;        ret
;.not8:
;        ret
;------------------------------------------------------------------------------;
;GetC0Table
B0_56:
	mov dword [byte RegRegister + r___V0___b],  dword ___C0Table
	ret
;------------------------------------------------------------------------------;
;GetB0Table
B0_57:
	mov dword [byte RegRegister + r___V0___b],  dword ___B0Table
	ret
;------------------------------------------------------------------------------;
;ChangeClearPad(int)
;B0_5B:
;        mov eax,[RegRegister+___A0]                     ;8914 - ClearPadFunc
;        mov edx,[MemRegister+0x00008914]
;        mov [MemRegister+0x00008914],eax
;        mov [RegRegister+___V0],edx
;        ret
;------------------------------------------------------------------------------;
;ChangeClearRCnt(int index,int *func)
;C0_0A:
;        mov eax,[RegRegister+___A0]                     ;8600 - ClearRoot0
;        mov ecx,[RegRegister+___A1]                     ;8604 - ClearRoot1
;        mov edx,[MemRegister+0x00008600+eax*4]          ;8608 - ClearRoot2
;        mov [MemRegister+0x00008600+eax*4],ecx          ;860c - ClearRoot3
;        mov [RegRegister+___V0],edx
;        ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
;LOG_A0_30       db      "---HLE---MISC(A0:30)---srand( 0x%X )",13,10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
