#ifndef _RBPSE_CONST_H_
#define _RBPSE_CONST_H_

typedef struct {
	long    Data___Table___;
	long    Data___Memory___;
	long    Data___Dynarec___;
	long	reserved[13];
} RbPSeDataStruc;

typedef struct {
	long	Hook___Table___;
	long	Hook___HardWare8___;
	long	Hook___HardWare16___;
	long	Hook___HardWare32___;
	long	Hook___Opcode___;
	long	Hook___Function___;
	long	Hook___FunctionEx___;
	long	Hook___hleA0___;
	long	Hook___hleB0___;
	long	Hook___hleC0___;
	long	Hook___dma___;
	long	reserved[21];
} RbPSeHookStruc;

typedef struct {
	long	Log___Printf___;
	long	Write___Memory___;
	long	Write___Dynarec___;
	long	Clear___Memory___;
	long	Clear___Dynarec___;
	long	Convert___mem2dyn___;
	long	Convert___dyn2mem___;
	long	reserved[9];
} RbPSeFuncStruc;

typedef struct {
	long SourceType;
	char *SourceName;
	long ExecAddr;
	long Display;
	char *PluginsDir;
	char *ProfileDir;
	char *LogfileDir;
} RbPSeStartStruc;

#endif
